functions 5.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178
  1. #!/usr/bin/env bash
  2. export ZWAVE_JS_CONF="${SNAP}/lib/zwavejs2mqtt/node_modules/@zwave-js/config"
  3. function ensure_zwavejs_config {
  4. # Not needed anymore as of ZWAVEJS_EXTERNAL_CONFIG
  5. # if [ "$(find ${ZWAVE_JS_CONF} -maxdepth 0 -empty -exec echo empty \;)" == "empty" ]; then
  6. # logger "Config directory is empty, copying data from ${SNAP}/snap/zwave-js/config"
  7. # rsync -raz "${SNAP}/snap/zwave-js/config" "${ZWAVE_JS_CONF}/.."
  8. # else
  9. # logger "Config directory ${ZWAVE_JS_CONF} exists"
  10. # fi
  11. return 0
  12. }
  13. function get_network_key {
  14. if [ -f "${SNAP_DATA}/settings.json" ]; then
  15. SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  16. if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  17. echo "${SETTINGS_KEY}"
  18. return 1
  19. fi
  20. return 0
  21. fi
  22. return 0
  23. }
  24. function same_network_key {
  25. # SKIP NOW: NETWORK KEY SHOULD NOT BE USED
  26. # FAVOR SETTING
  27. # if [ -f "${SNAP_DATA}/settings.json" ]; then
  28. # SETTINGS_KEY=$(jq '.zwave.networkKey' -r ${SNAP_DATA}/settings.json)
  29. # if [ "${SETTINGS_KEY}" != "" ] && [ "${1}" != "${SETTINGS_KEY}" ]; then
  30. # echo "${SETTINGS_KEY}"
  31. # return 1
  32. # fi
  33. # return 0
  34. # fi
  35. return 0
  36. }
  37. function cpy_2_zui {
  38. if snapctl is-connected zui-store; then
  39. if [ "$(ls "${SNAP_COMMON}/zui-store" | wc -l)" -ne 0 ]; then
  40. echo "The zui-store (${SNAP_COMMON}/zui-store) is not empty, exiting..." >&2
  41. exit 1
  42. elif [ -d "${SNAP_COMMON}/zui-store" ]; then
  43. cp -rf "${SNAP_DATA}/"* "${SNAP_COMMON}/zui-store"
  44. if [ $? -ne 0 ]; then
  45. echo "Failed copying data from ${SNAP_COMMON}/zui-store" >&2
  46. return 1
  47. fi
  48. mv "${SNAP_COMMON}/zui-store/zwave*.{log,json}" "${SNAP_COMMON}/zui-store/logs"
  49. mv "${SNAP_COMMON}/zui-store/logs" "${SNAP_COMMON}/zui-store/z2m-logs"
  50. rm -rf "${SNAP_COMMON}/zui-store/.ext-config"
  51. else
  52. echo "Missing directory ${SNAP_COMMON}/zui-store, cannot write to it. Exiting..." >&2
  53. exit 1
  54. fi
  55. else
  56. echo "Can not copy config: Missing connection «store-dir» (offered by <zwave-js-ui>: `snap install zwave-js-ui`)." >&2
  57. echo "Please install and connect with:" 1>&2
  58. echo "$ snap connect ${SNAP_NAME}:zui-store zwave-js-ui:store-dir" >&2
  59. return 1
  60. fi
  61. return 0
  62. }
  63. function plug_connected {
  64. if ! snapctl is-connected "${1}"; then
  65. echo "Missing plug: «${1}»" >&2
  66. echo "Connect with:"
  67. if [ "${1}" == "serial-port" ]; then
  68. echo "$ sudo snap connect ${SNAP_NAME}:${1} <slot name>"
  69. else
  70. echo "$ sudo snap connect ${SNAP_NAME}:${1}"
  71. fi
  72. return 1
  73. fi
  74. return 0
  75. }
  76. function plugs_connected {
  77. MISSING=0
  78. RAW_OUT=$(plug_connected "raw-usb")
  79. RAW_RES=$?
  80. SERIAL_OUT=$(plug_connected "serial-port")
  81. SERIAL_RES=$?
  82. if [ $RAW_RES -ne 0 -a $SERIAL_RES -ne 0 ]; then
  83. echo $RAW_OUT
  84. echo "----- OR -----"
  85. echo $SERIAL_OUT
  86. echo "See ${SNAP_NAME}.help for more info on the serial-port plug"
  87. MISSING=1
  88. fi
  89. plug_connected "hardware-observe"
  90. if [ $? -ne 0 ]; then
  91. MISSING=1
  92. fi
  93. if [ $MISSING -ne 0 ]; then
  94. return 1
  95. fi
  96. return 0
  97. }
  98. function is_root {
  99. if [ ${EUID:-$(id -u)} -eq 0 ]; then
  100. return 0
  101. fi
  102. return 1
  103. }
  104. function require_root {
  105. is_root
  106. if [ $? -eq 1 ]; then
  107. echo "Running as root is required." >&2
  108. echo "Re-run with sudo."
  109. exit 1
  110. fi
  111. }
  112. function testnset_config {
  113. logger "${SNAP_NAME}: Testing ${1}, or setting ${2}"
  114. RES=$(snapctl get ${1})
  115. if [ $? -ne 0 ] || [ -z "${RES}" ]; then
  116. logger "${SNAP_NAME}: Setting ${1}=${2}"
  117. RES=$(snapctl set ${1}=${2})
  118. if [ $? -ne 0 ]; then
  119. logger "${RES}"
  120. exit 1
  121. fi
  122. return 0
  123. fi
  124. return 0
  125. }
  126. function test_priority_dir {
  127. Z2M_SETTINGS="${SNAP_DATA}/settings.json"
  128. if ! [ -w "${Z2M_SETTINGS}" ]; then
  129. return 1
  130. fi
  131. PRIORITY_DIR=$(echo "$(sed -E "s#$(dirname ${SNAP_DATA})/(current|[0-9]+)#${SNAP_DATA}#g" <<< $(cat "${Z2M_SETTINGS}" | jq '.zwave.deviceConfigPriorityDir'))" | tr -d '"')
  132. if [[ -d $(dirname "${PRIORITY_DIR}") && -w "${PRIORITY_DIR}" ]]; then
  133. jq --arg deviceConfigPriorityDir ${PRIORITY_DIR} '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  134. if [ $? -eq 0 ]; then
  135. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  136. fi
  137. elif ! [[ "${PRIORITY_DIR}" =~ ^"$(dirname $SNAP_DATA)"* ]]; then
  138. jq --arg deviceConfigPriorityDir "${SNAP_DATA}/devicePriorityConfig" '.zwave.deviceConfigPriorityDir = $deviceConfigPriorityDir' "${Z2M_SETTINGS}" > "${Z2M_SETTINGS}.tmp"
  139. if [ $? -eq 0 ]; then
  140. mv "${Z2M_SETTINGS}.tmp" "${Z2M_SETTINGS}"
  141. fi
  142. fi
  143. return 0
  144. }
  145. function test_default_config {
  146. testnset_config "server.host" "localhost"
  147. testnset_config "server.port" 8091
  148. testnset_config "server.ssl" false
  149. testnset_config "server.force-disable-ssl" false
  150. testnset_config "session.cookie-secure" $(snap get server.ssl)
  151. testnset_config "session.secret" $(uuid)
  152. testnset_config "mqtt.name" ""
  153. }